import ecs100.*;
import java.awt.Color;
import java.io.*;

/**
 * Allows user to enter a sequence of numbers that is
 * stored to a file.
 */
public class Nums{
    public static final double BASE = 500;
    public static final double BAR_WIDTH = 4;

    private PrintStream output;    // the file that the numbers are printed to
    private double barX = 0;       // position of the next bar to draw

    public void setupGUI(){
        UI.addButton("New File", this::doNewFile);
        UI.setMouseListener(this::doMouse);
        UI.addButton("Quit", UI::quit); 
        this.doNewFile();
    }

    /** start a new file of numbers */
    public void doNewFile(){
        if (this.output!= null){
           this.output.close();
        }
        try {
            this.output = new PrintStream(UIFileChooser.save("File to save numbers to"));
        }catch(IOException e){UI.println("File error :" + e);}
    }

    /** respond to the mouse releases - add a new number */
    public void doMouse(String action, double x, double y){
        if (action.equals("released")){
            double num = BASE - y;     //work out the number,
            UI.fillRect(this.barX, y, BAR_WIDTH, num); //draw the bar
            this.barX = this.barX + BAR_WIDTH+1;
            UI.println(num);     // print the number in text pane
            if (this.output != null){
                this.output.println(num);// print the number to the file.
            }
        }
    }

    public static void main(String[] args){
        new Nums().setupGUI();
    }

}

